<?
    set_time_limit( 0 );
    require ("logUtil.php");

    function create_zip( $files = array(), $destination = '', $overwrite = true, $base = true )
    {
        if( file_exists( $destination ) && !$overwrite )
            return false;

        $valid_files = array( );
        if( is_array( $files ) )
        {
            foreach( $files as $file )
            {
                if( file_exists( $file ) )
                    $valid_files[] = $file;
            }
        }

        if( count( $valid_files ) )
        {
            if( !class_exists( 'ZipArchive' ) )
            {
                if( is_file( '/usr/bin/zip' ) )
                {
                    $filesToZip = array( );
                    foreach( $valid_files as $file )
                    {
                        if( is_dir( $file ) === true )
                        {
                            $recDir = new RecursiveIteratorIterator( new RecursiveDirectoryIterator( $file ), RecursiveIteratorIterator::SELF_FIRST );
                            foreach( $recDir as $f )
                            {
                                if( is_file( $f ) === true )
                                    $filesToZip[] = $f;
                            }
                        }
                        else
                            $filesToZip[] = $file;
                    }
                    if( sizeof( $filesToZip ) > 0 )
                        exec( "zip /tmp/$zipName " . implode( ' ', $filesToZip ) );

                    return file_exists( "/tmp/{$zipName}" );
                }
                return false;
            }
            else
            {
                $zip = new ZipArchive( );

                if( $zip->open( $destination, $overwrite ? ZIPARCHIVE::OVERWRITE : ZIPARCHIVE::CREATE ) !== true )
                    return false;
                foreach( $valid_files as $file )
                {
                    if( $base )
                        $zip->addFile( $file, basename( $file ) );
                    else
                        $zip->addFile( $file, $file );
                }
                $zip->close( );
                return file_exists( $destination );
            }
        }
        else
            return false;
    }

    function zipFolderRec( $source, $destination )
    {
        if( file_exists( $source ) === true )
        {

            if( !class_exists( 'ZipArchive' ) )
            {
                if( is_file( '/usr/bin/zip' ) )
                {
                    $filesToZip = array( );
                    $source = realpath( $source );
                    if( is_dir( $source ) === true )
                    {
                        $recDir = new RecursiveIteratorIterator( new RecursiveDirectoryIterator( $source ), RecursiveIteratorIterator::SELF_FIRST );
                        foreach( $recDir as $f )
                        {
                            if( is_file( $f ) === true )
                                $filesToZip[] = $f;
                        }
                    }
                    else
                        $filesToZip[] = $source;

                    if( sizeof( $filesToZip ) > 0 )
                        exec( "zip $destination " . implode( ' ', $filesToZip ) );

                    return file_exists( $destination );
                }
                return false;
            }
            else
            {
                $zip = new ZipArchive( );
                if( $zip->open( $destination, ZIPARCHIVE::CREATE ) === true )
                {
                    $source = realpath( $source );
                    if( is_dir( $source ) === true )
                    {
                        $files = new RecursiveIteratorIterator( new RecursiveDirectoryIterator( $source ), RecursiveIteratorIterator::SELF_FIRST );
                        foreach( $files as $file )
                        {
                            $file = realpath( $file );
                            if( is_file( $file ) === true )
                            {
                                $zip->addFile( $file, $file );
                            }
                        }
                    }
                    else if( is_file( $source ) === true )
                        $zip->addFile( $source, $source );
                }
                $zip->close( );
            }
        }
        if( file_exists( $destination ) )
            return true;
        else
            return false;
    }

    function includeSDir( $files, $sdirFiles )
    {
        for( $x = 0; $x < sizeof( $sdirFiles ); $x++ )
        {
            $ext = substr( $sdirFiles[$x], sizeof( $sdirFiles[$x] ) - 5 );
            if( $ext == ".log" )
            {
                $files[sizeof( $files )] = $sdirFiles[$x];
            }
        }
        return $files;
    }

    function getAllFiles( $folder )
    {
        $dir = dir( $folder );
        $files = array( );
        while( ($sDir = $dir->read( )) !== false )
        {
            if( $sDir != '.' && $sDir != '..' )
            {
                if( is_dir( $folder . "/" . $sDir ) )
                {
                    $sdirFiles = getAllFiles( $folder . "/" . $sDir );
                    $files = includeSDir( $files, $sdirFiles );
                }
                else
                    $files[sizeof( $files )] = $folder . "/" . $sDir;
            }
        }
        return $files;
    }

    if( isset( $_REQUEST['file'] ) && $_REQUEST['type'] == "file" )
    {
        $tmpFile = explode( "/", base64_decode( $_REQUEST['file'] ) );

        $zip_name = LogUtil::getTempDir( ) . '/' . $tmpFile[sizeof( $tmpFile ) - 1] . '.zip';
        $files_to_zip = array( base64_decode( $_REQUEST['file'] ) );

        $result = create_zip( $files_to_zip, $zip_name );

        if( $result )
            echo $zip_name;
        else
            echo '';

    }
    elseif( isset( $_REQUEST['folder'] ) && $_REQUEST['type'] == "folder" )
    {
        $folder = base64_decode( $_REQUEST['folder'] );

        if( substr( $folder, -1 ) == "/" )
            $folder = rtrim( $folder, '/' );

        $tmpFolder = explode( "/", $folder );
        $zip_name = LogUtil::getTempDir( ) . '/' . $tmpFolder[sizeof( $tmpFolder ) - 1] . '.zip';

        $result = zipFolderRec( $folder . '/', $zip_name );

        if( $result )
            echo $zip_name;
        else
            echo '';
    }
?>